package jpg2ascii;

import java.awt.image.*;
import java.io.*;

public class Jpg2Ascii{
	public static void main(String[] args){
		//TODO: keep this file small -> extra class file
		String fileName = "", mapFileName = "jpg2ascii/Map.asc";
		final String fnf = "file not found";
		int height = 0 , width = 0; 
		int cps = 75;

		if (args.length >= 1 && !args[0].startsWith("--help")) {
			fileName = args[0];
			if (args.length >= 2){
				mapFileName = args[1];
				if (args.length >= 3){
					cps = Integer.parseInt(args[2]);
				}
			}
		}
		else {
			System.out.println("usage: java -jar Jpg2Ascii.jar Image.jpg [Ascii.map] [cps]");
			System.exit(0);
		}

		// read jpg-file
		try{
			InputStream jpgin = new BufferedInputStream(new FileInputStream(args[0]));
			com.sun.image.codec.jpeg.JPEGImageDecoder decoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGDecoder(jpgin);
			BufferedImage image = decoder.decodeAsBufferedImage();
			height = image.getHeight();
			width = image.getWidth();
			jpgin.close();
			System.out.println("the image "+fileName+" has "+height+" * "+width+" pixel\n");
			Pixel pi = new Pixel();
			// (filename, wished chearacter)
			pi.setOptions(fileName, mapFileName, width, height, cps);
			// let's get it done!
			pi.extractPixels(image);
		//TODO question, wether to proceed or not
		} catch (FileNotFoundException err){
			System.out.println(fileName+": "+fnf);
		} catch (Exception err){
			err.printStackTrace();
		}
	}
}
